## Gnu Privacy Guard

### Generate

    gpg --full-gen-key

### Basic usage

Signature sig mode:

    gpg --detach-sign file.ext

Signature asc mode:

    gpg --armor --sign file.ext

Verify:

    gpg --verify file.sig

### My user-id

    gpg -K

### All users-ids

    gpg -k

### Copy Public Key

    gpg --export --armor <user-id> | xclip -sel clip

### Copy Private key (Caution)

    gpg --export-secret-keys -a <user-id> | xclip -sel clip

### Change password gpg

    gpg --edit-key <user-id>

    passwd

### Debug gpg

    dirmngr --debug-level guru

### Import key:

    gpg --recv-keys $esefingerprint

### Import key from server:

    gpg --recv-keys <user-id> --keyserver pgp.mit.edu

### Export key 0:

    gpg --export --armor <user-id> > public.key

### Export key 1:

    gpg --armor --output public.key --export <user-id>

### Export key to server

    gpg  --keyserver pgp.mit.edu --send-keys <user-id>

## Cifrado
### Cifrado simétrico
#### Cifrar

    gpg --symmetric <miarchivo>

#### Descifrado

    gpg --output <archivo.ext> --decrypt <archivo.gpg>

### Cifrado Asimétrico
#### Encryt

    gpg --recipient <user-id> --encrypt archivo.ext

#### Decrypt

    gpg --output archivo.ext --decrypt archivo.ext.gpg

## Refresh keys

    gpg --refresh-keys

### wiki
https://www.gnupg.org/gph/es/manual/book1.html
