## Guía de Instalación de Hyperbola GNU/Linux-libre v0.3 [Modo DOS]

- [Primeros pasos](#primeros-pasos)
- [Formateo de Particiones](#formateo-de-particiones)
- [Organización de Particiones](#organización-de-particiones)
- [Instalación del Sistema Base](#instalación-del-sistema-base)
- [Configuración Principal](#configuración-principal)
- [Creación de usuario](#creación-de-usuario)
- [Interfaz gráfica BASE](#interfaz-gráfica-base)
  - [Mesa demos](#mesa-demos)
  - [Instalar paquete de vídeo (según marca de su tarjeta de vídeo)](#instalar-paquete-de-vídeo-según-marca-de-su-tarjeta-de-vídeo)
  - [Componentes Xenocara](#componentes-xenocara)
  - [Agrega permisos](#agrega-permisos)
  - [Soporte de audio](#soporte-de-audio)
  - [Configurar pulseaudio](#configurar-pulseaudio)
  - [Ajuste en el idioma de teclado de Xenocara](#ajuste-en-el-idioma-de-teclado-de-xenocara)
- [ESCRITORIOS](#escritorios)
  - [¿Cómo iniciar Xfce4?](#cómo-iniciar-xfce4)
- [UTILIDADES](#utilidades)
  - [Sincronizar el Horario Local](#sincronizar-el-horario-local)
  - [Compresores de archivos](#compresores-de-archivos)
  - [Detector de particiones](#detector-de-particiones)
  - [Soporte multimedia](#soporte-multimedia)
  - [Navegadores](#navegadores)
  - [LibreOffice](#libreoffice)
    - [Corrección de ortografía](#corrección-de-ortografía)
    - [Reglas de división de palabras](#reglas-de-división-de-palabras)
    - [Sinónimos](#sinónimos)
  - [Seguridad](#seguridad)
  - [Comunicación](#comunicación)
  - [Impresoras](#impresoras)

Lo primero a realizar después de ingresar el disco o USB de instalación.
Seguimos los siguientes pasos:

### Primeros pasos

root@hyperiso# `loadkeys es`

root@hyperiso# `ping -c 3 gnu.org`

> Comprobamos si hay conexión a Internet

root@hyperiso# `cfdisk`

- En el caso de la partición elegida como **swap** ir a la opción "Type" y seleccionar **82 (Linux swap)** de la lista.
- En el caso de la partición elegida como **/boot**, se selecciona **"bootable"**

ejemplo:

```bash
sda1=/boot
sda2=/
sda3=/home
sda4=swap

Recomendaciones:
/boot   = 300MB
/       = 40GB
/home   = personalizado
swap    = igual a la RAM
```

#### Conexión por Wi-fi

Detectar `wifi`

    iw dev

Activar dispositivo

    ip link set <nombre-de-dispositivo> up

Activar Internet con `wpa_supplicant`

    wpa_supplicant -B -i <nombre-de-dispositivo> -c <(wpa_passphrase "ssid" "psk")

Renovar IPv4 con `dhcpcd`

    dhcpcd <nombre-de-dispositivo>

> nombre-de-dispositivo: ejemplo, wlp3s0

### Formateo de Particiones:

- En `/boot` se utilizará **ext2**

    - root@hyperiso# `mkfs -t ext2 /dev/sda1`

- En `/` se utilizará **ext4**

    - root@hyperiso# `mkfs -t ext4 /dev/sda2`

- En `/home`, se utilizará **ext4**

    - root@hyperiso# `mkfs -t ext4 /dev/sda3`

- En `swap`, se utilizará **mkswap**

    - root@hyperiso# `mkswap /dev/sda4`

- Activamos la partición swap

    - root@hyperiso# `swapon /dev/sda4`

### Organización de Particiones

- Montamos root en /mnt

    - root@hyperiso# `mount /dev/sda2 /mnt`

- Creamos los directorios de las otras particiones

    - root@hyperiso# `mkdir /mnt/boot`

    - root@hyperiso# `mkdir /mnt/home`

- Montamos las particiones correspondientes

    - root@hyperiso# `mount /dev/sda1 /mnt/boot`

    - root@hyperiso# `mount /dev/sda3 /mnt/home`

### Instalación del Sistema Base

root@hyperiso# `pacman -Sy hyperbola-keyring`

> Con el comando anterior actualizamos las llaves de la iso

root@hyperiso# `pacstrap /mnt base base-devel`

root@hyperiso# `pacstrap /mnt grub-bios`

root@hyperiso# `pacstrap /mnt networkmanager`

root@hyperiso# `pacstrap /mnt xf86-input-synaptics`

> Instalar `xf86-input-synaptics` Solo en laptops (ordenadores portátiles)

root@hyperiso# `pacstrap /mnt kernel-firmware`


### Configuración Principal

- Generar el archivo fstab

    - root@hyperiso# `genfstab -U -p /mnt >> /mnt/etc/fstab`

- Efectuar chroot y configurar el sistema base

    - root@hyperiso# `arch-chroot /mnt`

- Establecer nombre del equipo para esto tenemos que editar el archivo `/etc/conf.d/hostname`:

    - sh-4.2# `echo gnulinux > /etc/hostname`

> Nombre a escoger, puede ser cualquier nombre en minúscula. eg. `gnulinux`

- Configurar idioma

    - sh-4.2# `ln -s /usr/share/zoneinfo/America/Lima /etc/localtime`

- Actualizar hora del sistema (Opcional)

    - sh-4.2# `hwclock --systohc --utc`

- Activar nuestra localización, descomentar

    - sh-4.2# `nano /etc/locale.gen`

      ```
      es_ES.UTF-8 UTF-8
      ```

- Establecer las preferencias de localización

    - sh-4.2# `echo LANG=es_ES.UTF-8 > /etc/locale.conf`

- Generamos la localización

    - sh-4.2# `locale-gen`

- Como la configuración regional, debe configurar el mapa de teclas en el archivo `/etc/conf.d/keymaps`

    - sh-4.2# `nano /etc/conf.d/keymaps`

            keymap="es"

- Instalación del Grub

    - sh-4.2# `grub-install --target=i386-pc --recheck /dev/sda`

- Creamos el archivo grub.cfg

    - sh-4.2# `grub-mkconfig -o /boot/grub/grub.cfg`

- Generar ramdisk

    - sh-4.2# `mkinitcpio -p linux-libre-lts`

- Establecer contraseña del usuario root

    - sh-4.2# `passwd`

- Cerrar chroot

    - sh-4.2# `exit`

- Desmontar particiones

    - root@hyperiso# `umount /mnt/{boot,home,}`

    - root@hyperiso# `reboot`

- Una vez reiniciado el sistema iniciamos sesión como usuario root

- Activar Network Manager

    - root@gnulinux$ `su` ← Colocar su contraseña de usuario `root`

    - root@gnulinux# `rc-service NetworkManager start`

    - root@gnulinux# `rc-update add NetworkManager default`

### Creación de usuario

root@gnulinux# `groupadd usuario`

root@gnulinux# `useradd -m -g users -G audio,disk,games,http,input,lp,network,optical,power,scanner,storage,sys,video,wheel -g usuario -s /bin/bash miusuario`

- Asignamos contraseña

    - root@gnulinux# `passwd miusuario`

- Editamos el archivo `/etc/sudoers`

    - root@gnulinux# `nano /etc/sudoers`

eliminamos el "#" al inicio de la línea: `%whell ALL=(ALL) ALL`

- Reiniciamos el equipo

    - root@gnulinux# `reboot`

- Nos conectamos a la red inalámbrica con NetworkManager (Solo necesario si se quiere conectar a Red Wi-Fi)

    - root@gnulinux$ `sudo nmcli dev wifi connect "SSID" password "contraseña"`

        Nombre de la red Wi-Fi sin las comillas ejemplo: somoslibres
        Se escribe la contraseña sin las comillas, ejemplo: micontrasegura

        Ejemplo: `sudo nmcli dev wifi connect somoslibres password micontrasegura`

- Actualización del sistema

    - root@gnulinux$ `sudo pacman -Syu`

### Interfaz gráfica BASE

root@gnulinux$ `su`

> Colocar su contraseña de usuario `root`

root@gnulinux# `pacman -S xorg-server xorg-xinit xorg-utils xorg-server-utils`

#### Mesa demos

root@gnulinux# `pacman -S mesa mesa-demos`

#### Instalar paquete de vídeo (según marca de su tarjeta de vídeo)

Comprobar marca:
root@gnulinux# `lspci | grep -e VGA`

Instalar una de ellas dependiendo de la marca:

root@gnulinux# `pacman -S xorg-video-intel`

root@gnulinux# `pacman -S xorg-video-nouveau`

root@gnulinux# `pacman -S xorg-video-vesa`

#### Componentes Xenocara

root@gnulinux# `pacman -S xenocara-server`

#### Agrega permisos

root@gnulinux# `nano /etc/X11/Xwrapper.config`

```
allowed_users=anybody
```

root@gnulinux# `cp /etc/X11/xinit/xserverrc ~/.xserverrc`

#### Soporte de audio

root@gnulinux# `pacman -S pulseaudio pulseaudio-alsa alsa-utils pavucontrol`

root@gnulinux# `rc-update add alsasound default`

#### Configurar pulseaudio

root@gnulinux# `nano -w /etc/pulse/client.conf`

descomentar `autospawn`

```bash
autospawn = yes
```

#### Ajuste en el idioma de teclado de Xenocara

root@gnulinux# `nano -w /etc/X11/xorg.conf.d/00-keyboard.conf`

y dentro colocar:

```bash
Section "InputClass"
    Identifier "system-keyboard"
    MatchIsKeyboard "on"
    Option "XkbLayout" "es"
    Option "XkbModel" "pc105"
    Option "XkbOptions" "grp:alt_shift_toggle,compose:rwin,lv3:ralt_switch,numpad:pc"
EndSection
```

ó descargar con: `wget https://pastebin.com/raw/MXYBr5g5 -O  /etc/X11/xorg.conf.d/00-keyboard.conf`

- Tipografías

    - root@gnulinux# `pacman -S ttf-liberation ttf-bitstream-vera ttf-dejavu ttf-droid`

A continuación, procederemos a crear las carpetas personales.
En caso de tener planeado instalar **GNOME** o **PLASMA KDE** como entorno de escritorio,
obvie este paso, puesto que la instalación de GNOME o PLASMA KDE generan de forma
automática los directorios.

- Instalación del generador de directorios: `pacman -S xdg-user-dirs`

- Creación automática de directorios: `xdg-user-dirs-update`

### ESCRITORIOS:
- Xfce4

    - root@gnulinux# `pacman -S xfce4 xfce4-goodies`
    - root@gnulinux# `pacman -S gamin gvfs`
    - root@gnulinux# `pacman -S network-manager-applet`
    - root@gnulinux# `pacman -S gnome-keyring`
    - root@gnulinux# `pacman -S volumeicon`

#### ¿Cómo iniciar Xfce4?

- Iniciar Xfce4 con Xorg (opción 1)

    - root@gnulinux$ `exec startxfce4`

- Instalar gestor de inicio de sesión (opción 2)

    - root@gnulinux$ `sudo pacman -S lightdm lightdm-gtk-greeter`

    - root@gnulinux$ `sudo rc-update add lightdm default`

- Reiniciar

    - root@gnulinux$ `sudo reboot`

### UTILIDADES
#### Sincronizar el Horario Local:

root@gnulinux# `pacman -S ntp`

root@gnulinux# `ntpdate -u hora.roa.es`

#### Compresores de archivos:

Normalmente nos topamos con carpetas comprimidas en ZIP, RAR y/u otro formato que se suelen intercambiar en Internet. En muchos entornos de escritorio, suelen incluir el suyo (File Roller en GNOME, Engrampa en MATE, Ark en KDE y XArchiver en XFCE/LXDE). Para mejorar la funcionalidad de estos compresores de archivos, le añadiremos el soporte para 7Z, RAR, ZIP y otros.

- GZip (conocidos por la extensión “.tar.gz”): `pacman -S zlib haskell-zlib`
- BZip2: `pacman -S bzip2`
- RAR: `pacman -S unar `
- 7Zip: `pacman -S p7zip lrzip`
- ZIP: `pacman -S zip libzip unzip`

#### Detector de particiones:

- Utilitario Udisk: # `pacman -S udevil autofs udisks2`
- Lectura y escritura de sistemas de archivos NTFS: # `pacman -S ntfs-3g`
- Lectura y escritura de sistema de archivos FAT32: # `pacman -S fatsort exfat-utils dosfstools`
- Lectura y escritura de sistemas de archivos XFS: # `pacman -S xfsprogs`

#### Soporte multimedia
Para poder reproducir archivos multimedia, es necesario poder tener los códecs y el
reproductor. Para ello, procederemos a instalar los códecs ffmpeg y gstreamer,
además de los reproductores.
Aquí les sugiero algunos reproductores que les puede resultar útiles.

- Códecs: `pacman -S ffmpeg gstreamer gst-libav gst-plugins-bad gst-plugins-good gst-plugins-ugly gst-plugins-base gstreamer-vaapi gst-transcoder ffms2 x264 libtheora opus libvorbis libvpx libogg`
- Reproductor Audacious: `pacman -S audacious`
- Reproductor SMPlayer: `pacman -S smplayer smplayer-themes smplayer-skins`
- Reproductor VLC: `pacman -S vlc`
- Reproductor MPV: `pacman -S mpv`

#### Navegadores:
Existen navegadores incluidos por los entornos de escritorio como GNOME con Epiphany
o KDE con Konqueror. No obstante, gracias a los desarrolladores Hyperbola tenemos a
**Iceweasel-UXP**, **Iceape-UXP**, **Icedove-UXP**.

- Iceweasel-UXP: `pacman -S iceweasel-uxp iceweasel-uxp-l10n-es-es`
- Iceape-UXP: `pacman -S iceape-uxp iceape-uxp-l10n-es-es`
- Icedove-UXP: `pacman -S icedove-uxp icedove-uxp-l10n-es-es`

#### LibreOffice
Por lo general, a la hora de usar un Sistema Operativo, por lo menos se tiene una suite de oficina.
En GNU/Linux, se acostumbra a tener una. Felizmente en Hyperbola, Libreoffice se presenta es su versión estable.
Lo único que necesitaríamos es efectuar el siguiente comando:

root@gnulinux# `pacman -S libreoffice-still libreoffice-still-l10n-es`

##### Corrección de ortografía
Para revisar la ortografía necesitará hunspell y un diccionario de hunspell (como hunspell-es, hunspell-en, etc.)

root@gnulinux# `pacman -S hunspell hunspell-es`

##### Reglas de división de palabras
Para disponer de las reglas de división también necesitará hyphen + un conjunto de reglas (hyphen-en, hyphen-de)

root@gnulinux# `pacman -S hyphen hyphen-es`

##### Sinónimos
Para la opción Sinónimos necesitará mythes + un libro de sinónimos de mythes (mythes-en mythes-es)

root@gnulinux# `pacman -S mythes mythes-es`

#### Seguridad
La seguridad es importante al navegar por Internet es por ello que Hyperbola provee de una herramienta llamada **firejail** en combinación con una interfaz gráfica **firetools**.

root@gnulinux# `pacman -S firejail firetools`

#### Comunicación
La comunicación a través de Internet es requerida a día de hoy. En Hyperbola tenemos programas para la comunicación a través de Internet:
- Gajim
    - root@gnulinux# `pacman -S gajim python2-axolotl`

- Tox
    - qtox: # `pacman -S qtox`
    - toxic: # `pacman -S toxic`

#### Impresoras

root@gnulinux# `pacman -S cups cups-filters cups-pdf`

root@gnulinux# `pacman -S ghostscript gsfonts gutenprint`

root@gnulinux# `pacman -S foomatic-db foomatic-db-engine foomatic-db-gutenprint-ppds hplip splix foomatic-db-ppds`

###### Administrador de Impresoras

root@gnulinux# `pacman -S system-config-printer`

###### Habilitar servicios

root@gnulinux# `rc-update add cupsd default`

root@gnulinux# `rc-service cupsd start`
