### Escribiendo grub

$ nano -w grub.cfg

```
insmod part_gpt
insmod part_msdos
insmod fat
insmod efi_gop
insmod efi_uga
insmod video_bochs
insmod video_cirrus
insmod font

if loadfont "${prefix}/fonts/unicode.pf2" ; then
  insmod gfxterm
  set gfxmode="1024x768x32;auto"
  terminal_input console
  terminal_output gfxterm
fi

menuentry "Hyperbola GNU/Linux-libre x86_64" {
  set gfxpayload=keep
  search --no-floppy --set=root --label HYPER_v029
  echo 'Loading linux-libre-lts kernel...'
  linux  /hyperbola/boot/x86_64/vmlinuz archisobasedir=hyperbola hyperisolabel=HYPER_v029 add_efi_memmap
  echo 'Cargando imagen de memoria inicial...'
  initrd /hyperbola/boot/x86_64/hyperiso.img
}

menuentry "UEFI Shell x86_64 v2" {
  search --no-floppy --set=root --label HYPER_v029
  chainloader /EFI/shellx64_v2.efi
}

menuentry "UEFI Shell x86_64 v1" {
  search --no-floppy --set=root --label HYPER_v029
  chainloader /EFI/shellx64_v1.efi
}
```


### Construyendo bootia32.efi

```bash
grub-mkstandalone -d /usr/lib/grub/i386-efi/ \
    -O i386-efi --modules="part_gpt part_msdos" \
    --fonts="unicode" --locales="uk" --themes="" \
    -o "/output/path/bootia32.efi" "boot/grub/grub.cfg=/to/path/grub.cfg" \
    -v
```

Recuerde cambiar `/output/path` y `/to/path/` por sus respectivo directorios

### Copiar bootia32.efi
Copie el archivo (bootia32.efi) al directorio /EFI/BOOT de la memoria usb

ejemplo:

    cp -v /run/hyperiso/bootmnt/EFI/BOOT/bootx64.efi /mnt/boot/efi/EFI/BOOT/BOOTX64.EFI
